global astp

# --- fonctions d'intialisation ---

proc astp_create { {listobj ""} } {
   # ===================================================================
   # usage : astp_create { "::buf::create" "::cam::create audine lpt1" }
   #
   # ===================================================================
   global astp
   #
   set astp(result) ""
   #
   set astp(numbuf) 0
   set astp(numcam) 0
   set astp(numtel) 0
   foreach obj $listobj {
      set objname [lindex $obj 0]
      if {[string first buf $objname]!=-1} {
         incr astp(numbuf)
         set astp(buf,$astp(numbuf)) [eval $obj]
      }
      if {[string first cam $objname]!=-1} {
         incr astp(numcam)
         set astp(cam,$astp(numcam)) [eval $obj]
      }
      if {[string first tel $objname]!=-1} {
         incr astp(numtel)
         set astp(tel,$astp(numtel)) [eval $obj]
      }
   }
}

proc astp_finit { filename } {
   # ===================================================================
   # usage : astp_finit { oujensui.txt }
   #
   # ===================================================================
   global astp
   set fid [open $filename w]
   close $fid
}

# --- fonctions de transfert Client -> Tcl ---

proc astp_param_in { {listparam ""} } {
   # ===================================================================
   # usage : astp_paramin { i 200 5 }
   #
   # ===================================================================
   global astp
   set k 0
   foreach param $listparam {
      incr k
      set astp(p,$k) $param
   }
}

proc astp_buf_load { {listbuff ""} } {
   # ===================================================================
   # usage : astp_buf_load { "1 #0.fit" }
   #
   # ===================================================================
   global astp
   foreach buff $listbuff {
      set numbuf [lindex $buff 0]
      set filename [lindex $buff 1]
      buf$numbuf load $filename
   }
}

# --- fonction d'execution ---

proc astp_source { scriptname } {
   # ===================================================================
   # usage : astp_source { offset2.tcl }
   #
   # ===================================================================
   global astp
   set astp(error) noerror
   if {[catch {set astp(result) [source $scriptname ]} error]!=0} {
      set astp(error) error
      set astp(result) $error
   }
}

proc astp_fappend { filename } {
   # ===================================================================
   # usage : astp_fappend { oujensui.txt }
   #
   # ===================================================================
   global astp
   set fid [open $filename a]
   puts -nonewline $fid $astp(result) 
   close $fid
}

# --- fonctions de transfert Tcl -> Client ---

proc astp_buf_save { {listbuff ""} } {
   # ===================================================================
   # usage : astp_buf_save { "1 #0.fit" }
   #
   # ===================================================================
   global astp
   foreach buff $listbuff {
      set numbuf [lindex $buff 0]
      set filename [lindex $buff 1]
      buf$numbuf save $filename
   }
}

proc astp_result { filename } {
   # ===================================================================
   # usage : astp_result { result.txt }
   #
   # ===================================================================
   global astp
   set fid [open $filename w]
   puts $fid $astp(error)
   puts $fid $astp(result)
   close $fid
}

# --- fonctions de terminaison ---

proc astp_delete { filename } {
   # ===================================================================
   # usage : astp_delete signal.txt
   #
   # ===================================================================
   global astp
   set fid [open $filename w]
   close $fid
   #
   if {$astp(numbuf)!=0} {
      for {set k 1} {$k<=$astp(numbuf)} {incr k} {
         ::buf::delete $astp(buf,$astp(numbuf))
      }
   }
   if {$astp(numcam)!=0} {
      for {set k 1} {$k<=$astp(numcam)} {incr k} {
         ::buf::delete $astp(cam,$astp(numcam))
      }
   }
   if {$astp(numtel)!=0} {
      for {set k 1} {$k<=$astp(numtel)} {incr k} {
         ::buf::delete $astp(tel,$astp(numtel))
      }
   }
}


# --- ajout de fonctions utiles 

proc loadima { filename {numbuf 1} } {
   buf$numbuf load $filename
}

proc saveima { filename {numbuf 1} } {
   buf$numbuf save $filename
}

proc acq { exptime binning {numcam 1} } {
   cam$numcam exptime $exptime
   cam$numcam bin [list $binning $binning]
   cam$numcam acq
   vwait status_cam$numcam
}

proc goto { radec {numtel 1} } {
   set rahms [mc_angle2hms [lindex $radec 0]]
   set decdms [mc_angle2dms [lindex $radec 1] dec]
   set ra "[lindex $rahms 0]h[lindex $rahms 1]m[lindex $rahms 2]s"
   set dec "[lindex $decdms 0]d[lindex $decdms 1]m[lindex $decdms 2]s"
   tel$numtel goto [list $ra $dec]
}

proc offset { value {numbuf 1} } {
   buf$numbuf offset $value
}

proc sub { filename value {numbuf 1} } {
   buf$numbuf sub $filename $value
}

# --- en crire d'autres...
